.\"	$NetBSD: mount_mfs.8,v 1.14 2006/01/15 19:49:25 dsl Exp $
.\"
.\" Copyright (c) 1983, 1987, 1991, 1993, 1994
.\"	The Regents of the University of California.  All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. Neither the name of the University nor the names of its contributors
.\"    may be used to endorse or promote products derived from this software
.\"    without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.\"     @(#)newfs.8	8.6 (Berkeley) 5/3/95
.\"
.Dd December 8, 2007
.Dt MOUNT_MFS 8
.Os
.Sh NAME
.Nm mount_mfs
.Nd mount a memory based file system
.Sh SYNOPSIS
.Nm mount_mfs
.Op Fl N
.Op Fl a Ar maxcontig
.Op Fl b Ar block-size
.Op Fl d Ar rotdelay
.Op Fl e Ar maxbpg
.Op Fl f Ar frag-size
.Op Fl g Ar groupname
.Op Fl i Ar bytes-per-inode
.Op Fl m Ar free-space
.Op Fl n Ar inodes
.Op Fl o Ar options
.Op Fl p Ar permissions
.Op Fl s Ar size
.Op Fl u Ar username
.Op Fl V Ar verbose
.Ar special node
.Sh DESCRIPTION
.Nm
is used to build a file system in virtual memory and then mount it
on a specified node.
.Nm
exits and the contents of the file system are lost
when the file system is unmounted.
If
.Nm
is sent a signal while running,
for example during system shutdown,
it will attempt to unmount its
corresponding file system.
.Ar special
is ignored.
.Pp
Options with numeric arguments may contain an optional (case-insensitive)
suffix:
.Bl -tag -width 3n -offset indent -compact
.It b
Bytes; causes no modification.
(Default)
.It k
Kilo; multiply the argument by 1024
.It m
Mega; multiply the argument by 1048576
.It g
Giga; multiply the argument by 1073741824
.El
.Pp
The following options define the general layout policies:
.Bl -tag -width Fl
.It Fl N
Causes the memory file system parameters to be printed out
without really mounting the memory file system.
.It Fl a Ar maxcontig
This specifies the maximum number of contiguous blocks that will be
laid out before forcing a rotational delay (see the
.Fl d
option).
The default value is 8.
See
.Xr tunefs 8
for more details on how to set this option.
.It Fl b Ar block-size
The block size of the file system, in bytes.
It must be a power of two.
The smallest allowable size is 4096 bytes.
The default size depends upon the size of the file system:
.Pp
.Bl -tag -width "file system size" -compact -offset indent
.It Sy "file system size"
.Ar block-size
.It \&\*[Lt] 20 MB
4 KB
.It \&\*[Lt] 1024 MB
8 KB
.It \&\*[Gt]\&= 1024 MB
16 KB
.El
.It Fl d Ar rotdelay
This specifies the expected time (in milliseconds) to service a transfer
completion interrupt and initiate a new transfer on the same disk.
The default is 0 milliseconds.
See
.Xr tunefs 8
for more details on how to set this option.
.ne 1i
.It Fl e Ar maxbpg
This indicates the maximum number of blocks any single file can
allocate out of a cylinder group before it is forced to begin
allocating blocks from another cylinder group.
The default is about one quarter of the total blocks in a cylinder group.
See
.Xr tunefs 8
for more details on how to set this option.
.It Fl f Ar frag-size
The fragment size of the file system in bytes.
It must be a power of two ranging in value between
.Ar block-size Ns /8
and
.Ar block-size .
The optimal
.Ar block-size : Ns Ar frag-size
ratio is 8:1.
Other ratios are possible, but are not recommended,
and may produce unpredictable results.
The default size depends upon the size of the file system:
.Pp
.Bl -tag -width "file system size" -compact -offset indent
.It Sy "file system size"
.Ar frag-size
.It \&\*[Lt] 20 MB
0.5 KB
.It \&\*[Lt] 1024 MB
1 KB
.It \&\*[Gt]\&= 1024 MB
2 KB
.El
.It Fl g Ar groupname
This specifies the group name or group id of the root
inode of the file system.
.It Fl i Ar bytes-per-inode
This specifies the density of inodes in the file system.
If fewer inodes are desired, a larger number should be used;
to create more inodes a smaller number should be given.
The default is to create an inode for every
.Pq 4 * Ar frag-size
bytes of data space:
.Pp
.Bl -tag -width "file system size" -compact -offset indent
.It Sy "file system size"
.Ar bytes-per-inode
.It \&\*[Lt] 20 MB
2 KB
.It \&\*[Lt] 1024 MB
4 KB
.It \&\*[Gt]\&= 1024 MB
8 KB
.El
.It Fl m Ar free-space
The percentage of space reserved from normal users; the minimum free
space threshold.
The default value used is 5%.
See
.Xr tunefs 8
for more details on how to set this option.
.It Fl n Ar inodes
This specifies the number of inodes for the filesystem.
If both
.Fl i
and
.Fl n
are specified then
.Fl n
takes precedence.
.It Fl o
Options are specified with a
.Fl o
flag followed by a comma separated string of options.
See the
.Xr mount 8
man page for possible options and their meanings.
.It Fl p Ar permissions
This specifies the permissions of the root
inode of the file system.
.It Fl s Ar size
The size of the file system in sectors.
An
.Sq s
suffix will be interpreted as the number of sectors (the default).
All other suffixes are interpreted as per other numeric arguments,
except that the number is converted into sectors by dividing by the
default sector size (which is 512 bytes)
after suffix interpretation.
.It Fl u Ar username
This specifies the user name or user id of the root
inode of the file system.
.It Fl V Ar verbose
This controls the amount of information written to stdout:
.Bl -tag -width 3n -offset indent -compact
.It 0
No output
.It 1
Overall size and cylinder group details.
.It 2
A progress bar (dots ending at right hand margin).
.It 3
The first few super-block backup sector numbers are displayed before the
progress bar.
.It 4
All the super-block backup sector numbers are displayed (no progress bar).
.El
The default is 0.
If
.Fl N
is specifed
.Nm
stops before outputting the progress bar.
.El
.Sh NOTES
The owner and group ids of the root node of the new file system
are set to the effective uid and gid of the user mounting
the file system.
.Sh EXAMPLES
Mount a 32 MB mfs on /tmp:
.Pp
.Dl mount_mfs -s 32m swap /tmp
.Sh SEE ALSO
.Xr disktab 5 ,
.Xr fs 5 ,
.Xr disklabel 8 ,
.Xr diskpart 8 ,
.Xr dumpfs 8 ,
.\" .Xr format 8 ,
.Xr fsck_ffs 8 ,
.Xr fsirand 8 ,
.Xr mount 8 ,
.Xr newfs 8 ,
.Xr tunefs 8
.Rs
.%A M. McKusick
.%A W. Joy
.%A S. Leffler
.%A R. Fabry
.%T A Fast File System for UNIX ,
.%J ACM Transactions on Computer Systems 2
.%V 3
.%P pp 181-197
.%D August 1984
.%O (reprinted in the BSD System Manager's Manual)
.Re
.Sh HISTORY
The
.Nm
command appeared in
.Bx 4.2 .
.Sh BUGS
The
.Cm async
.Xr mount 8
option is currently disabled in this file system because it causes
hangs when writing lots of data.
The problem is that MFS needs to allocate pages to clean pages, so if
it waits until the last minute to clean pages then there may not be
any of them available to do the cleaning.
